# 
# Copyright (C) 2008 Red Hat, Inc.
# Written by Scott Seago <sseago@redhat.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA  02110-1301, USA.  A copy of the GNU General Public License is
# also available at http://www.gnu.org/copyleft/gpl.html.

ActionController::Routing::Routes.draw do |map|

  # The priority is based upon order of creation: first created -> highest priority.
  
  # Sample of regular route:
  # map.connect 'products/:id', :controller => 'catalog', :action => 'view'
  # Keep in mind you can assign values other than :controller and :action

  # Sample of named route:
  # map.purchase 'products/:id/purchase', :controller => 'catalog', :action => 'purchase'
  # This route can be invoked with purchase_url(:id => product.id)

  # You can have the root of your site routed by hooking up '' 
  # -- just remember to delete public/index.html.
  map.default '', :controller => 'dashboard'

  map.login '/login', :controller => 'resources', :action => 'list'
  map.logout '/logout', :controller => 'resources', :action => 'list'

  # Allow downloading Web Service WSDL as a file with an extension
  # instead of a file named 'wsdl'
  map.connect ':controller/service.wsdl', :action => 'wsdl'

  # Install the default route as the lowest priority.
  map.connect 'graph/flexchart_data/:id/:target/:startTime/:endTime/:dataFunction', :controller => 'graph', :action => 'flexchart_data'
  map.connect 'graph/host_chart_data/:id/:target/:startTime/:resolution/:dataFunction', :controller => 'graph', :action => 'host_chart_data'
  map.connect ':controller/:action/:id.:format'
  map.connect ':controller/:action/:id'

  # We put routes for the REST API _after_ the default routes so that we
  # don't disturb existing routes for the Server
  # FIXME: Eventually, we want to rename the controllers in a way that makes
  # REST work out of the box, and use these as the default routes
  map.resources :hosts, :controller => 'host'
  map.resources :storage_pools, :controller => 'storage'
  map.resources :storage_volumes, :controller => 'storage_volume'
  map.resources :hardware_pools, :controller => 'hardware' do |hardware_pools|
    hardware_pools.resources :hosts, :controller => 'host'
    hardware_pools.resources :storage_pools, :controller => 'storage'
  end
  map.resources :vms, :controller => 'vm'
end
