/* http://keith-wood.name/svg.html
   SVG graphing extension for jQuery v1.0.1.
   Written by Keith Wood (kbwood@iprimus.com.au) August 2007.
   Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and 
   MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses. 
   Please attribute the author if you use it. */
var svgGraphing=null;(function($){svgManager.addExtension('graph',SVGGraph);svgGraphing=new SVGGraphing();function SVGGraphing(){this.regional=[];this.regional['']={percentageText:'Percentage'};this.region=this.regional['']}$.extend(SVGGraphing.prototype,{_chartTypes:[],addChartType:function(a,b){this._chartTypes[a]=b},chartTypes:function(){return this._chartTypes}});function SVGGraph(a){this._root=a;this._drawNow=true;for(var b in svgGraphing._chartTypes){this._chartType=svgGraphing._chartTypes[b];break}this._chartOptions={};this._title={value:'',offset:25,settings:{text_anchor:'middle'}};this._area=[0.1,0.1,0.8,0.9];this._chartFormat={fill:'none',stroke:'black'};this._gridlines=[];this._series=[];this._onstatus=null;this._chartGroup=this._root.group(null,'graph');this.xAxis=new SVGGraphAxis();this.xAxis.title('',40);this.yAxis=new SVGGraphAxis();this.yAxis.title('',40);this.x2Axis=null;this.y2Axis=null;this.legend=new SVGGraphLegend()}$.extend(SVGGraph.prototype,{X:0,Y:1,W:2,H:3,L:0,T:1,R:2,B:3,_percentageAxis:new SVGGraphAxis(svgGraphing.region.percentageText,0,100,10,0),chartType:function(a,b){if(arguments.length==0){return this._chartType}var c=svgGraphing._chartTypes[a];if(c){this._chartType=c;this._chartOptions=$.extend({},b||{})}this._drawGraph();return this},chartOptions:function(a){if(arguments.length==0){return this._chartOptions}this._chartOptions=$.extend({},a);this._drawGraph();return this},chartFormat:function(a,b,c){if(arguments.length==0){return this._chartFormat}if(typeof b=='object'){c=b;b=null}this._chartFormat=$.extend($.extend({fill:a},(b?{stroke:b}:{})),c||{});this._drawGraph();return this},chartArea:function(a,b,c,d){if(arguments.length==0){return this._area}this._area=(isArray(a)?a:[a,b,c,d]);this._drawGraph();return this},gridlines:function(a,b){if(arguments.length==0){return this._gridlines}this._gridlines=[(typeof a=='string'?{stroke:a}:a),(typeof b=='string'?{stroke:b}:b)];this._drawGraph();return this},title:function(a,b,c){if(arguments.length==0){return this._title}if(typeof b=='object'){c=b;b=null}this._title={value:a,offset:b||this._title.offset,settings:$.extend({text_anchor:'middle'},c||{})};this._drawGraph();return this},addSeries:function(a,b,c,d,e,f){if(typeof e=='object'){f=e;e=null}this._series[this._series.length]=new SVGGraphSeries(a,b,c,d,e,f||{});this._drawGraph();return this},series:function(){return this._series},noDraw:function(){this._drawNow=false;return this},redraw:function(){this._drawNow=true;this._drawGraph();return this},status:function(a){this._onstatus=a;return this},_drawGraph:function(){if(!this._drawNow){return}while(this._chartGroup.firstChild){this._chartGroup.removeChild(this._chartGroup.firstChild)}if(!this._chartGroup.parent){this._root._svg.appendChild(this._chartGroup)}this._chartType.drawGraph(this)},_drawTitle:function(){this._root.text(this._chartGroup,this._root._width()/2,this._title.offset,this._title.value,this._title.settings)},_getDims:function(a){a=a||this._area;var b=(a[this.L]>1?a[this.L]:this._root._width()*a[this.L]);var c=(a[this.T]>1?a[this.T]:this._root._height()*a[this.T]);var d=(a[this.R]>1?a[this.R]:this._root._width()*a[this.R])-b;var e=(a[this.B]>1?a[this.B]:this._root._height()*a[this.B])-c;return[b,c,d,e]},_drawChartBackground:function(a,b){var c=this._root.group(this._chartGroup,'background');var d=this._getDims();this._root.rect(c,d[this.X],d[this.Y],d[this.W],d[this.H],this._chartFormat);if(this._gridlines[0]&&this.yAxis._ticks.major&&!b){this._drawGridlines(c,this.yAxis,true,d,this._gridlines[0])}if(this._gridlines[1]&&this.xAxis._ticks.major&&!a){this._drawGridlines(c,this.xAxis,false,d,this._gridlines[1])}return c},_drawGridlines:function(a,b,c,d,e){var g=this._root.group(a,e);var f=(c?d[this.H]:d[this.W])/(b._scale.max-b._scale.min);var h=Math.floor(b._scale.min/b._ticks.major)*b._ticks.major;h=(h<b._scale.min?h+b._ticks.major:h);while(h<=b._scale.max){var v=(c?b._scale.max-h:h-b._scale.min)*f+(c?d[this.Y]:d[this.X]);this._root.line(g,(c?d[this.X]:v),(c?v:d[this.Y]),(c?d[this.X]+d[this.W]:v),(c?v:d[this.Y]+d[this.H]));h+=b._ticks.major}},_drawAxes:function(a){var b=this._getDims();if(this.xAxis&&!a){if(this.xAxis._title){this._root.text(this._chartGroup,b[this.X]+b[this.W]/2,b[this.Y]+b[this.H]+this.xAxis._titleOffset,this.xAxis._title)}this._drawAxis(this.xAxis,'xAxis',b[this.X],b[this.Y]+b[this.H],b[this.X]+b[this.W],b[this.Y]+b[this.H])}if(this.yAxis){if(this.yAxis._title){this._root.text(this._chartGroup,0,0,this.yAxis._title,{text_anchor:'middle',transform:'translate('+(b[this.X]-this.yAxis._titleOffset)+','+(b[this.Y]+b[this.H]/2)+') rotate(-90)'})}this._drawAxis(this.yAxis,'yAxis',b[this.X],b[this.Y],b[this.X],b[this.Y]+b[this.H])}if(this.x2Axis&&!a){if(this.x2Axis._title){this._root.text(this._chartGroup,b[this.X]+b[this.W]/2,b[this.X]-this.x2Axis._titleOffset,this.x2Axis._title)}this._drawAxis(this.x2Axis,'x2Axis',b[this.X],b[this.Y],b[this.X]+b[this.W],b[this.Y])}if(this.y2Axis){if(this.y2Axis._title){this._root.text(this._chartGroup,0,0,this.y2Axis._title,{text_anchor:'middle',transform:'translate('+(b[this.X]+b[this.W]+this.y2Axis._titleOffset)+','+(b[this.Y]+b[this.H]/2)+') rotate(-90)'})}this._drawAxis(this.y2Axis,'y2Axis',b[this.X]+b[this.W],b[this.Y],b[this.X]+b[this.W],b[this.Y]+b[this.H])}},_drawAxis:function(a,b,c,d,e,f){var g=(d==f);var h=this._root.group(this._chartGroup,b,a._lineFormat);var i=this._root.group(this._chartGroup,b+'Labels',$.extend({text_anchor:(g?'middle':'end')},a._labelFormat));this._root.line(h,c,d,e,f);if(a._ticks.major){var j=(e>(this._root._width()/2)&&f>(this._root._height()/2));var k=(g?e-c:f-d)/(a._scale.max-a._scale.min);var l=a._ticks.size;var m=Math.floor(a._scale.min/a._ticks.major)*a._ticks.major;m=(m<a._scale.min?m+a._ticks.major:m);var n=(!a._ticks.minor?a._scale.max+1:Math.floor(a._scale.min/a._ticks.minor)*a._ticks.minor);n=(n<a._scale.min?n+a._ticks.minor:n);var o=this._getTickOffsets(a,j);while(m<=a._scale.max||n<=a._scale.max){var p=Math.min(m,n);var q=(p==m?l:l/2);var v=(g?c:d)+(g?p-a._scale.min:a._scale.max-p)*k;this._root.line(h,(g?v:c+q*o[0]),(g?d+q*o[0]:v),(g?v:c+q*o[1]),(g?d+q*o[1]:v));if(p==m){this._root.text(i,(g?v:c-l),(g?d+2*l:v),(a._labels?a._labels[p]:''+p))}m+=(p==m?a._ticks.major:0);n+=(p==n?a._ticks.minor:0)}}},_getTickOffsets:function(a,b){return[(a._ticks.position==(b?'in':'out')||a._ticks.position=='both'?-1:0),(a._ticks.position==(b?'out':'in')||a._ticks.position=='both'?+1:0),]},_getPercentageAxis:function(){this._percentageAxis._title=svgGraphing.region.percentageText;return this._percentageAxis},_getTotals:function(){var a=[];var b=(this._series.length?this._series[0]._values.length:0);for(var i=0;i<b;i++){a[i]=0;for(var j=0;j<this._series.length;j++){a[i]+=this._series[j]._values[i]}}return a},_drawLegend:function(){if(!this.legend._show){return}var g=this._root.group(this._chartGroup,'legend');var a=this._getDims(this.legend._area);this._root.rect(g,a[this.X],a[this.Y],a[this.W],a[this.H],this.legend._bgSettings);var b=a[this.W]>a[this.H];var c=this._series.length;var d=(b?a[this.W]:a[this.H])/c;var e=a[this.X]+5;var f=a[this.Y]+(b?a[this.H]/2:d/2);for(var i=0;i<c;i++){var h=this._series[i];this._root.rect(g,e+(b?i*d:0),f+(b?0:i*d)-this.legend._sampleSize,this.legend._sampleSize,this.legend._sampleSize,{fill:h._fill,stroke:h._stroke,stroke_width:1});this._root.text(g,e+(b?i*d:0)+this.legend._sampleSize+5,f+(b?0:i*d),h._name,this.legend._textSettings)}},_showStatus:function(a){var b=(!this._onstatus?'':this._onstatus.toString().replace(/function (.*)\([\s\S]*/m,'$1'));return(!this._onstatus?{}:{onmouseover:'window.parent.'+b+'(\''+a+'\');',onmouseout:'window.parent.'+b+'(\'\');'})}});function SVGGraphAxis(a,b,c,d,e){this._title=a||'';this._titleFormat={};this._titleOffset=0;this._labels=null;this._labelFormat={};this._lineFormat={stroke:'black'};this._ticks={major:d||10,minor:e||0,size:10,position:'out'};this._scale={min:b||0,max:c||100};this._crossAt=0}$.extend(SVGGraphAxis.prototype,{scale:function(a,b){if(arguments.length==0){return this._scale}this._scale.min=a;this._scale.max=b;return this},ticks:function(a,b,c,d){if(arguments.length==0){return this._ticks}if(typeof c=='string'){d=c;c=null}this._ticks.major=a;this._ticks.minor=b;this._ticks.size=c||10;this._ticks.position=d||'out';return this},title:function(a,b,c){if(arguments.length==0){return{title:this._title,offset:this._titleOffset,format:this._titleFormat}}if(typeof b=='object'){c=b;b=null}this._title=a;if(b!=null){this._titleOffset=b}if(c){this._titleFormat=c}return this},labels:function(a,b){if(arguments.length==0){return{labels:this._labels,format:this._labelFormat}}this._labels=a;if(b){this._labelFormat=b}return this},line:function(a,b,c){if(arguments.length==0){return this._lineFormat}if(typeof b=='object'){c=b;b=null}$.extend(this._lineFormat,{stroke:a,stroke_width:b||1});$.extend(this._lineFormat,c||{});return this}});var B='green';var C='black';function SVGGraphSeries(a,b,c,d,e,f){this._name=a||'';this._values=b||[];this._axis=1;this._fill=c||B;this._stroke=d||C;this._strokeWidth=e||1;this._settings=f||{}}$.extend(SVGGraphSeries.prototype,{name:function(a){if(arguments.length==0){return this._name}this._name=a;return this},values:function(a,b){if(arguments.length==0){return this._values}if(isArray(a)){valus=a;a=null}this._name=a||this._name;this._values=b;return this},format:function(a,b,c,d){if(arguments.length==0){return $.extend({fill:this._fill,stroke:this._stroke,stroke_width:this._strokeWidth},this._settings)}if(typeof c=='object'){d=c;c=null}this._fill=a||B;this._stroke=b||this._stroke;this._strokeWidth=c||this._strokeWidth;$.extend(this._settings,d||{});return this}});function SVGGraphLegend(a,b){this._show=true;this._area=[0.9,0.1,1.0,0.9];this._sampleSize=15;this._bgSettings=a||{stroke:'gray'};this._textSettings=b||{}}$.extend(SVGGraphLegend.prototype,{show:function(a){if(arguments.length==0){return this._show}this._show=a;return this},area:function(a,b,c,d){if(arguments.length==0){return this._area}this._area=(isArray(a)?a:[a,b,c,d]);return this},settings:function(a,b,c){if(arguments.length==0){return{sampleSize:this._sampleSize,bgSettings:this._bgSettings,textSettings:this._textSettings}}if(typeof a=='object'){c=b;b=a;a=null}if(a){this._sampleSize=a}this._bgSettings=b;if(c){this._textSettings=c}return this}});function roundNumber(a,b){return Math.round(a*Math.pow(10,b))/Math.pow(10,b)}var D=['barWidth (number) - the width of each bar','barGap (number) - the gap between sets of bars'];function SVGColumnChart(){}$.extend(SVGColumnChart.prototype,{title:function(){return'Basic column chart'},description:function(){return'Compare sets of values as vertical bars with grouped categories.'},options:function(){return D},drawGraph:function(a){a._drawChartBackground(true);var b=a._chartOptions.barWidth||10;var c=a._chartOptions.barGap||10;var d=a._series.length;var e=(d?(a._series[0])._values.length:0);var f=a._getDims();var g=f[a.W]/((d*b+c)*e+c);var h=f[a.H]/(a.yAxis._scale.max-a.yAxis._scale.min);this._chart=a._root.group(a._chartGroup,'chart');for(var i=0;i<d;i++){this._drawSeries(a,i,d,b,c,f,g,h)}a._drawTitle();a._drawAxes(true);this._drawXAxis(a,d,e,b,c,f,g);a._drawLegend()},_drawSeries:function(a,b,c,d,e,f,h,j){var k=a._series[b];var g=a._root.group(this._chart,'series'+b,$.extend({stroke:k._stroke,stroke_width:k._strokeWidth},k._settings||{}));for(var i=0;i<k._values.length;i++){a._root.rect(g,f[a.X]+h*(e+i*(c*d+e)+(b*d)),f[a.Y]+j*(a.yAxis._scale.max-k._values[i]),h*d,j*k._values[i],$.extend({fill:k._fill},a._showStatus(k._name+' '+k._values[i])))}},_drawXAxis:function(a,b,c,d,e,f,g){var h=a.xAxis;if(h._title){a._root.text(a._chartGroup,f[a.X]+f[a.W]/2,f[a.Y]+f[a.H]+h._titleOffset,h._title,{text_anchor:'middle'})}var j=a._root.group(a._chartGroup,'xAxis',h._lineFormat);var k=a._root.group(a._chartGroup,'xAxisLabels',$.extend({text_anchor:'middle'},h._labelFormat));a._root.line(j,f[a.X],f[a.Y]+f[a.H],f[a.X]+f[a.W],f[a.Y]+f[a.H]);if(h._ticks.major){var l=a._getTickOffsets(h,true);for(var i=1;i<c;i++){var x=f[a.X]+g*(e/2+i*(b*d+e));a._root.line(j,x,f[a.Y]+f[a.H]+l[0]*h._ticks.size,x,f[a.Y]+f[a.H]+l[1]*h._ticks.size)}for(var i=0;i<c;i++){var x=f[a.X]+g*(e/2+(i+0.5)*(b*d+e));a._root.text(k,x,f[a.Y]+f[a.H]+2*h._ticks.size,(h._labels?h._labels[i]:''+i))}}}});function SVGStackedColumnChart(){}$.extend(SVGStackedColumnChart.prototype,{title:function(){return'Stacked column chart'},description:function(){return'Compare sets of values as vertical bars showing '+'relative contributions to the whole for each category.'},options:function(){return D},drawGraph:function(a){var b=a._drawChartBackground(true,true);var c=a._getDims();if(a._gridlines[0]&&a.xAxis._ticks.major){a._drawGridlines(b,a._getPercentageAxis(),true,c,a._gridlines[0])}var d=a._chartOptions.barWidth||10;var e=a._chartOptions.barGap||10;var f=a._series.length;var g=(f?(a._series[0])._values.length:0);var h=c[a.W]/((d+e)*g+e);var i=c[a.H];this._chart=a._root.group(a._chartGroup,'chart');this._drawColumns(a,f,g,d,e,c,h,i);a._drawTitle();a._root.text(a._chartGroup,0,0,svgGraphing.region.percentageText,{text_anchor:'middle',transform:'translate('+(c[a.X]-a.yAxis._titleOffset)+','+(c[a.Y]+c[a.H]/2)+') rotate(-90)'});a._drawAxis(a._getPercentageAxis(),'yAxis',c[a.X],c[a.Y],c[a.X],c[a.Y]+c[a.H]);this._drawXAxis(a,g,d,e,c,h);a._drawLegend()},_drawColumns:function(a,b,c,d,e,f,h,j){var k=a._getTotals();var l=[];for(var i=0;i<c;i++){l[i]=0}for(var s=0;s<b;s++){var m=a._series[s];var g=a._root.group(this._chart,'series'+s,$.extend({stroke:m._stroke,stroke_width:m._strokeWidth},m._settings||{}));for(var i=0;i<m._values.length;i++){l[i]+=m._values[i];a._root.rect(g,f[a.X]+h*(e+i*(d+e)),f[a.Y]+j*(k[i]-l[i])/k[i],h*d,j*m._values[i]/k[i],$.extend({fill:m._fill},a._showStatus(m._name+' '+roundNumber(m._values[i]/k[i]*100,2)+'%')))}}},_drawXAxis:function(a,b,c,d,e,f){var g=a.xAxis;if(g._title){a._root.text(a._chartGroup,e[a.X]+e[a.W]/2,e[a.Y]+e[a.H]+g._titleOffset,g._title,{text_anchor:'middle'})}var h=a._root.group(a._chartGroup,'xAxis',g._lineFormat);var j=a._root.group(a._chartGroup,'xAxisLabels',$.extend({text_anchor:'middle'},g._labelFormat));a._root.line(h,e[a.X],e[a.Y]+e[a.H],e[a.X]+e[a.W],e[a.Y]+e[a.H]);if(g._ticks.major){var k=a._getTickOffsets(g,true);for(var i=1;i<b;i++){var x=e[a.X]+f*(d/2+i*(c+d));a._root.line(h,x,e[a.Y]+e[a.H]+k[0]*g._ticks.size,x,e[a.Y]+e[a.H]+k[1]*g._ticks.size)}for(var i=0;i<b;i++){var x=e[a.X]+f*(d/2+(i+0.5)*(c+d));a._root.text(j,x,e[a.Y]+e[a.H]+2*g._ticks.size,(g._labels?g._labels[i]:''+i))}}}});function SVGRowChart(){}$.extend(SVGRowChart.prototype,{title:function(){return'Basic row chart'},description:function(){return'Compare sets of values as horizontal rows with grouped categories.'},options:function(){return D},drawGraph:function(a){var b=a._drawChartBackground(true,true);var c=a._getDims();a._drawGridlines(b,a.yAxis,false,c,a._gridlines[0]);var d=a._chartOptions.barWidth||10;var e=a._chartOptions.barGap||10;var f=a._series.length;var g=(f?(a._series[0])._values.length:0);var h=c[a.W]/(a.yAxis._scale.max-a.yAxis._scale.min);var j=c[a.H]/((f*d+e)*g+e);this._chart=a._root.group(a._chartGroup,'chart');for(var i=0;i<f;i++){this._drawSeries(a,i,f,d,e,c,h,j)}a._drawTitle();this._drawAxes(a,f,g,d,e,c,j);a._drawLegend()},_drawSeries:function(a,b,c,d,e,f,h,j){var k=a._series[b];var g=a._root.group(this._chart,'series'+b,$.extend({stroke:k._stroke,stroke_width:k._strokeWidth},k._settings||{}));for(var i=0;i<k._values.length;i++){a._root.rect(g,f[a.X]+h*(0-a.yAxis._scale.min),f[a.Y]+j*(e+i*(c*d+e)+(b*d)),h*k._values[i],j*d,$.extend({fill:k._fill},a._showStatus(k._name+' '+k._values[i])))}},_drawAxes:function(a,b,c,d,e,f,g){var h=a.yAxis;if(h){if(h._title){a._root.text(a._chartGroup,f[a.X]+f[a.W]/2,f[a.Y]+f[a.H]+h._titleOffset,h._title,h._titleFormat)}a._drawAxis(h,'xAxis',f[a.X],f[a.Y]+f[a.H],f[a.X]+f[a.W],f[a.Y]+f[a.H])}var h=a.xAxis;if(h._title){a._root.text(a._chartGroup,0,0,h._title,{text_anchor:'middle',transform:'translate('+(f[a.X]-h._titleOffset)+','+(f[a.Y]+f[a.H]/2)+') rotate(-90)'})}var j=a._root.group(a._chartGroup,'yAxis',h._lineFormat);var k=a._root.group(a._chartGroup,'yAxisLabels',$.extend({text_anchor:'end'},h._labelFormat));a._root.line(j,f[a.X],f[a.Y],f[a.X],f[a.Y]+f[a.H]);if(h._ticks.major){var l=a._getTickOffsets(h,false);for(var i=1;i<c;i++){var y=f[a.Y]+g*(e/2+i*(b*d+e));a._root.line(j,f[a.X]+l[0]*h._ticks.size,y,f[a.X]+l[1]*h._ticks.size,y)}for(var i=0;i<c;i++){var y=f[a.Y]+g*(e/2+(i+0.5)*(b*d+e));a._root.text(k,f[a.X]-h._ticks.size,y,(h._labels?h._labels[i]:''+i))}}}});function SVGStackedRowChart(){}$.extend(SVGStackedRowChart.prototype,{title:function(){return'Stacked row chart'},description:function(){return'Compare sets of values as horizontal bars showing '+'relative contributions to the whole for each category.'},options:function(){return D},drawGraph:function(a){var b=a._drawChartBackground(true,true);var c=a._getDims();if(a._gridlines[0]&&a.xAxis._ticks.major){a._drawGridlines(b,a._getPercentageAxis(),false,c,a._gridlines[0])}var d=a._chartOptions.barWidth||10;var e=a._chartOptions.barGap||10;var f=a._series.length;var g=(f?(a._series[0])._values.length:0);var h=c[a.W];var i=c[a.H]/((d+e)*g+e);this._chart=a._root.group(a._chartGroup,'chart');this._drawRows(a,f,g,d,e,c,h,i);a._drawTitle();a._root.text(a._chartGroup,c[a.X]+c[a.W]/2,c[a.Y]+c[a.H]+a.xAxis._titleOffset,svgGraphing.region.percentageText,{text_anchor:'middle'});a._drawAxis(a._getPercentageAxis(),'xAxis',c[a.X],c[a.Y]+c[a.H],c[a.X]+c[a.W],c[a.Y]+c[a.H]);this._drawYAxis(a,g,d,e,c,i);a._drawLegend()},_drawRows:function(a,b,c,d,e,f,h,j){var k=a._getTotals();var l=[];for(var i=0;i<c;i++){l[i]=0}for(var s=0;s<b;s++){var m=a._series[s];var g=a._root.group(this._chart,'series'+s,$.extend({stroke:m._stroke,stroke_width:m._strokeWidth},m._settings||{}));for(var i=0;i<m._values.length;i++){a._root.rect(g,f[a.X]+h*l[i]/k[i],f[a.Y]+j*(e+i*(d+e)),h*m._values[i]/k[i],j*d,$.extend({fill:m._fill},a._showStatus(m._name+' '+roundNumber(m._values[i]/k[i]*100,2)+'%')));l[i]+=m._values[i]}}},_drawYAxis:function(a,b,c,d,e,f){var g=a.xAxis;if(g._title){a._root.text(a._chartGroup,0,0,g._title,{text_anchor:'middle',transform:'translate('+(e[a.X]-g._titleOffset)+','+(e[a.Y]+e[a.H]/2)+') rotate(-90)'})}var h=a._root.group(a._chartGroup,'yAxis',g._lineFormat);var j=a._root.group(a._chartGroup,'yAxisLabels',$.extend({text_anchor:'end'},g._labelFormat));a._root.line(h,e[a.X],e[a.Y],e[a.X],e[a.Y]+e[a.H]);if(g._ticks.major){var k=a._getTickOffsets(g,false);for(var i=1;i<b;i++){var y=e[a.Y]+f*(d/2+i*(c+d));a._root.line(h,e[a.X]+k[0]*g._ticks.size,y,e[a.X]+k[1]*g._ticks.size,y)}for(var i=0;i<b;i++){var y=e[a.Y]+f*(d/2+(i+0.5)*(c+d));a._root.text(j,e[a.X]-g._ticks.size,y,(g._labels?g._labels[i]:''+i))}}}});function SVGLineChart(){}$.extend(SVGLineChart.prototype,{title:function(){return'Basic line chart'},description:function(){return'Compare sets of values as continuous lines.'},options:function(){return[]},drawGraph:function(a){a._drawChartBackground();var b=a._getDims();var c=b[a.W]/(a.xAxis._scale.max-a.xAxis._scale.min);var d=b[a.H]/(a.yAxis._scale.max-a.yAxis._scale.min);this._chart=a._root.group(a._chartGroup,'chart');for(var i=0;i<a._series.length;i++){this._drawSeries(a,i,b,c,d)}a._drawTitle();a._drawAxes();a._drawLegend()},_drawSeries:function(a,b,c,d,e){var f=a._series[b];var g=a._root.createPath();for(var i=0;i<f._values.length;i++){var x=c[a.X]+i*d;var y=c[a.Y]+(a.yAxis._scale.max-f._values[i])*e;if(i==0){g.moveTo(x,y)}else{g.lineTo(x,y)}}a._root.path(this._chart,g,$.extend($.extend({id:'series'+b,fill:'none',stroke:f._stroke,stroke_width:f._strokeWidth},a._showStatus(f._name),f._settings||{})))}});function SVGPieChart(){}$.extend(SVGPieChart.prototype,{_options:['explode (number[]) - indexes of sections to explode out of the pie','explodeDist (number) - the distance to move an exploded section','pieGap (number) - the distance between pies for multiple values'],title:function(){return'Pie chart'},description:function(){return'Compare relative sizes of values as contributions to the whole.'},options:function(){return this._options},drawGraph:function(a){a._drawChartBackground(true,true);this._chart=a._root.group(a._chartGroup,'chart');var b=a._getDims();this._drawSeries(a,b);a._drawTitle();a._drawLegend()},_drawSeries:function(a,b){var c=a._getTotals();var d=a._series.length;var e=(d?(a._series[0])._values.length:0);var f=a._root.createPath();var g=a._chartOptions.explode||[];var h=a._chartOptions.explodeDist||10;var l=(e<=1?0:a._chartOptions.pieGap||10);var m=(b[a.W]-(e*l)-l)/e/2;var n=b[a.H]/2;var o=Math.min(m,n)-(g.length>0?h:0);var p=a._root.group(a._chartGroup,'xAxisLabels',$.extend({text_anchor:'middle'},a.xAxis._labelFormat));var q=[];for(var i=0;i<e;i++){var r=b[a.X]+m+(i*(2*Math.min(m,n)+l))+l;var s=b[a.Y]+n;var t=0;for(var j=0;j<d;j++){var u=a._series[j];if(i==0){q[j]=a._root.group(this._chart,'series'+j,$.extend({stroke:u._stroke,stroke_width:u._strokeWidth},u._settings||{}))}if(u._values[i]==0){continue}var v=(t/c[i])*2*Math.PI;t+=u._values[i];var w=(t/c[i])*2*Math.PI;var z=false;for(var k=0;k<g.length;k++){if(g[k]==j){z=true;break}}var x=r+(z?h*Math.cos((v+w)/2):0);var y=s+(z?h*Math.sin((v+w)/2):0);var A=u._name+' '+roundNumber((w-v)/2/Math.PI*100,2)+'%';a._root.path(q[j],f.reset().moveTo(x,y).lineTo(x+o*Math.cos(v),y+o*Math.sin(v)).arcTo(o,o,0,(w-v<Math.PI?0:1),1,x+o*Math.cos(w),y+o*Math.sin(w)).close(),$.extend({fill:u._fill},a._showStatus(A)))}if(a.xAxis){a._root.text(p,r,b[a.Y]+b[a.H]+a.xAxis._titleOffset,a.xAxis._labels[i])}}}});function isArray(a){return(a.constructor&&a.constructor.toString().match(/\Array\(\)/))}svgGraphing.addChartType('column',new SVGColumnChart());svgGraphing.addChartType('stackedColumn',new SVGStackedColumnChart());svgGraphing.addChartType('row',new SVGRowChart());svgGraphing.addChartType('stackedRow',new SVGStackedRowChart());svgGraphing.addChartType('line',new SVGLineChart());svgGraphing.addChartType('pie',new SVGPieChart())})(jQuery)